The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::BlitSaw Class Reference

STK band-limited sawtooth wave class. More...

`#include <BlitSaw.h>`

Inheritance diagram for stk::BlitSaw:

List of all members.

## Public Member Functions
| BlitSaw (StkFloat frequency=220.0)
| Class constructor.
| ~BlitSaw ()
| Class destructor.
void | reset ()
| Resets the oscillator state and phase to 0.
void | setFrequency (StkFloat frequency)
| Set the sawtooth oscillator rate in terms of a frequency in Hz.
void | setHarmonics (unsigned int nHarmonics=0)
| Set the number of harmonics generated in the signal.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (void)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK band-limited sawtooth wave class.

This class generates a band-limited sawtooth waveform using a closed-form algorithm reported by Stilson and Smith in "Alias-Free Digital Synthesis of Classic Analog Waveforms", 1996. The user can specify both the fundamental frequency of the sawtooth and the number of harmonics contained in the resulting signal.

If nHarmonics is 0, then the signal will contain all harmonics up to half the sample rate. Note, however, that this setting may produce aliasing in the signal when the frequency is changing (no automatic modification of the number of harmonics is performed by the setFrequency() function).

Based on initial code of Robin Davies, 2005. Modified algorithm code by Gary Scavone, 2005.

## Member Function Documentation

void stk::BlitSaw::setHarmonics | ( | unsigned int | nHarmonics = `0` | ) |

Set the number of harmonics generated in the signal.

This function sets the number of harmonics contained in the resulting signal. It is equivalent to (2 * M) + 1 in the BLIT algorithm. The default value of 0 sets the algorithm for maximum harmonic content (harmonics up to half the sample rate). This parameter is not checked against the current sample rate and fundamental frequency. Thus, aliasing can result if one or more harmonics for a given fundamental frequency exceeds fs / 2. This behavior was chosen over the potentially more problematic solution of automatically modifying the M parameter, which can produce audible clicks in the signal.

StkFrames & stk::BlitSaw::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Generator.

    00129 {
    00130 #if defined(_STK_DEBUG_)
    00131   if ( channel >= frames.channels() ) {
    00132     oStream_ << "BlitSaw::tick(): channel and StkFrames arguments are incompatible!";
    00133     handleError( StkError::FUNCTION_ARGUMENT );
    00134   }
    00135 #endif
    00136
    00137
    00138   StkFloat *samples = &frames[channel];
    00139   unsigned int hop = frames.channels();
    00140   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00141     *samples = BlitSaw::tick();
    00142
    00143   return frames;
    00144 }

The documentation for this class was generated from the following file:

- BlitSaw.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.